/*
 *   COPYRIGHT NOTICE: This code was written by Markus Mummert. All
 *   rights reserved. FOR LICENCE TERMS, SEE ACCOMPANYING FILE "LICENCE".
 */
/************************************************************************/
/*									*/
/*  Datei    :	DOUBFIFO.H - Import-Datei zu -> DOUBFIFO.C		*/
/*  Version  :	7.9.90/3						*/
/*  Autor    :	Markus Mummert						*/
/*									*/
/************************************************************************/

#ifndef DOUBFIFO_INCLUDED		/* Schutz vor mehrfach-include	*/
#define DOUBFIFO_INCLUDED

/*----------------------------------------------------------------------*/
/*  Import :								*/
/*----------------------------------------------------------------------*/

					
/*----------------------------------------------------------------------*/
/*  Import exclusiv fuer Source :					*/
/*----------------------------------------------------------------------*/

#ifdef DOUBFIFO_SOURCE
#include "portab.h"			/* Portabilitaetsdatei		*/
#endif

/*----------------------------------------------------------------------*/
/*  Export :								*/
/*----------------------------------------------------------------------*/

#define FIFOELEM	double		/* Fifoelement-Typ		*/

typedef struct {			/* FIFO-Descriptor mit Puffer-	*/
	FIFOELEM *ADR;			/*   adresse und -groesse,Index	*/
	int SIZE, HEAD, TAIL;		/*   auf LAST IN bzw. FIRST IN	*/
} FIFODESCR;

extern int createfifo();		/* Fifo ins Leben rufen		*/
extern 	   disposefifo();		/* Fifo aufloesen		*/
extern int fifolevel();			/* Fuellstand Fifo abfragen	*/
extern int eleminfifo();		/* Element in Fifo einschieben	*/
extern int outelemfifo();		/* Element aus Fifo holen	*/
extern int writefifo();			/* in Fifo ein best. Elem. schr.*/
extern int addfifo();			/* in Fifo ein best. Elem. add.	*/
extern int readfifo();			/* in Fifo ein best. Elem. les.	*/
extern     clearfifo();			/* Fifo-Inhalt loeschen		*/
extern     fillfifo();			/* Fifo mit Werten vollfuellen	*/

#endif					/* DOUBFIFO_INCLUDE		*/
/*******Dateiende********************************************************/

