/*
 *   COPYRIGHT NOTICE: This code was written by Markus Mummert. All
 *   rights reserved. FOR LICENCE TERMS, SEE ACCOMPANYING FILE "LICENCE".
 */
/************************************************************************/
/*									*/
/*  Datei    :	PORTAB.H 						*/
/*  Version  :	24.2.99/9						*/
/*  Autor    :	Markus Mummert						*/
/*									*/
/*  Kommentar:	Include-Datei zur Cross-Platform-Portabilitaet.		*/
/*		Zusammen mit PORTAB.C zu verwenden.			*/
/*									*/
/*  History  :  23.5.90/2 Mum						*/
/*		4.11.91/3 Bau,Mum sun-Portabilitaet			*/
/*		11.4.92/4 Mum i386-Portabilitaet, Einfuehrung PORTAB.C	*/
/*		7.8.98/5 Mum MOTOROLA... in UNNATURAL_BYTEORDER-flag	*/
/*		   umbenannt; mehr Uebersichtlichkeit			*/
/*		11.10.98/6 Mum extern-decl. malloc fuer atari, untested	*/
/*		13.10.98/7 Mum undef exp10 fuer sun entfernt		*/
/*		19.10.98/8 Mum keine leeres PORTAB.C per dummy_portab_c	*/
/*		24.2.99/9 Mum Umgrupp.; Minimalsupport MS-Visual-C++	*/
/*									*/
/************************************************************************/

#ifndef PORTAB_INCLUDED			/* Schutz vor mehrfach-inlclude	*/
#define PORTAB_INCLUDED

/*----------------------------------------------------------------------*/
/*  Import :								*/
/*----------------------------------------------------------------------*/

#include <stdio.h>
					
/*----------------------------------------------------------------------*/
/*  Export :								*/
/*----------------------------------------------------------------------*/

#ifdef unix
/*------UNIX------------*/

#include <malloc.h>			/* fuer size_t			*/
#define READ		"r"
#define WRITE		"w"
#define WORD		short		/* WORD soll 16bit lang sein	*/
#define BYTE		char		/* BYTE soll  8bit lang sein	*/
#define LONG		long		/* LONG soll 32bit lang sein	*/

					/* Altlasten ATARI-ST-Entwick-	*/
#define lmalloc(x) malloc((int)(x))	/* lung (s.u.):			*/
#define waitkey()			/*   waitkey unnoetig		*/
static long memavail()			/*   Speicheranw. ~1MB f. UNIX  */ 
{
	return(1000000L);
}

/*------UNIX------------*/
#endif

#ifdef _WIN32
/*---MS-Visual-C++------*/

#include <malloc.h>			/* fuer size_t			*/
#include <stdlib.h>			/* fuer RAND_MAX		*/
#define WIN_COMPATIBILITY_FUNCTIONS	/* siehe PORTAB.C		*/
#define READ		"rb"
#define WRITE		"wb"
#define WORD		short		/* WORD soll 16bit lang sein	*/
#define BYTE		char		/* BYTE soll  8bit lang sein	*/
#define LONG		long		/* LONG soll 32bit lang sein	*/
#define M_PI		3.14159265358979323846
#define M_PI_2		1.57079632679489661923
#define M_LN10		2.30258509299404568402
#define popen(x,y) _popen((x),(y))
#define pclose(x) _pclose(x)
					/* Altlasten ATARI-ST-Entwick-	*/
#define lmalloc(x) malloc((int)(x))	/* lung (s.u.):			*/
#define waitkey()			/*   waitkey unnoetig		*/
static long memavail()			/*   Speicheranw. ~1MB f. UNIX  */ 
{
	return(1000000L);
}

/*---MS-Visual-C++------*/
#endif

#ifdef atari
/*------ATARI-ST--------*/

#define	READ		"br"		/* binary read/write f. fopen	*/
#define WRITE		"bw"
#define WORD		int		/* WORD soll 16bit lang sein	*/
#define BYTE		char		/* BYTE soll  8bit lang sein	*/
#define LONG		long		/* LONG soll 32bit lang sein	*/
#define	MACHINE		"Atari ST"
#define BREAKKEY	"<CTRL-C>"

#include <osbind.h>			/* waitkey wartet auf Tasten- */
static waitkey()			/* druck,verhindert b. Fehler */
{					/* sof. Rueckkehr zum Desktop */
        fprintf(stderr, "        Taste druecken");
        fflush(stderr);  
        while (!Bconstat(2));		/* muss BIOS-Funktion sein,   */
        Bconin(2);			/* damit nicht unwirksam bei  */
}					/* Eingabe von Datei.         */
extern char* malloc();
#define	LEAVEMEM	0x10000		/* 64k RAM uebrig lassen	*/
					/* Fkt. gibt verfuegbaren	*/
static long memavail()			/* Speicher zurueck		*/
{
	return((long)(Malloc(-1L)) - LEAVEMEM);
}
/*------ATARI-ST--------*/
#endif

/*-----alle-Systeme----*/
					/* UNNATURAL_BYTEORDER fuer	*/
					/* big-endian/little-endian	*/
				       	/* Wandlung beim Schreiben/Les.	*/
#ifndef UNNATURAL_BYTEORDER		/* (vgl. portab.c)		*/
#define FREAD(b,s,n,f)	fread((b),(s),(n),(f))
#define FWRITE(b,s,n,f)	fwrite((b),(s),(n),(f))
#endif

#ifndef MACHINE
#define MACHINE ""
#endif

#ifndef BREAKKEY
#define BREAKKEY	"(systemabhaengig, z.B. <CTRL-C>)"
#endif

#ifndef exp10				/* ACHTUNG: <math.h> nicht nach	*/
#define exp10(x)	exp((x)*M_LN10) /* "portab.h" includieren	*/
#endif

#ifndef PI
#ifdef M_PI
#define PI		M_PI
#endif
#endif

#define Bit16		WORD
#define Bit32		LONG

/*----------------------*/

#endif					/* PORTAB_INCLUDED		*/
/*******Dateiende********************************************************/
