/*
 *   COPYRIGHT NOTICE: This code was written by Markus Mummert. All
 *   rights reserved. FOR LICENCE TERMS, SEE ACCOMPANYING FILE "LICENCE".
 */
/************************************************************************/
/*									*/
/*  Datei    :	SINTAB.H - Import/Export-Datei zu -> SINTAB.C		*/ 
/*  Version  :	9.1.90/3						*/
/*  Autor    :	Markus Mummert						*/
/*									*/
/************************************************************************/

#ifndef SINTAB_INCLUDED			/* Schutz vo mehrfach-include	*/
#define SINTAB_INCLUDED

/*----------------------------------------------------------------------*/
/*  Import :								*/
/*----------------------------------------------------------------------*/

#include "portab.h"			/* Portabilitaetsdatei		*/
					
/*----------------------------------------------------------------------*/
/*  Import exclusiv fuer Source :					*/
/*----------------------------------------------------------------------*/

#ifdef SINTAB_SOURCE
#endif					/* Keine			*/

/*----------------------------------------------------------------------*/
/*  Export :								*/
/*----------------------------------------------------------------------*/
					/* Makro cos/sin aus Tabelle	*/
					/* g_sintab,enthaelt 0x4001 	*/
					/* 16bit Werte von 0..0x7FFFF	*/
#define SINUSCOSINUS(phase, si, co)					\
	if ((phase) < 0x8000) {						\
    	  if ((phase) <= 0x4000) {					\
            (si) =   *(g_sintab+(phase));				\
	    (co) =   *(g_sintab+(unsigned WORD)(0x4000 - (phase)));	\
    	  } else {							\
      	    (si) =   *(g_sintab+(unsigned WORD)(0x8000 - (phase)));	\
      	    (co) = - *(g_sintab+(unsigned WORD)((phase) - 0x4000));	\
	  }								\
	} else {							\
 	  if ((phase) <= 0xC000) {					\
            (si) = - *(g_sintab+(unsigned WORD)((phase) - 0x8000));	\
            (co) = - *(g_sintab+(unsigned WORD)(0xC000 - (phase)));	\
    	  } else {							\
            (si) = - *(g_sintab+(unsigned WORD)(-(phase)));		\
	    (co) =   *(g_sintab+(unsigned WORD)((phase) - 0xC000));	\
	  }								\
	}

#define SINUS(phase, si)						\
	if ((phase) < 0x8000) {						\
    	  if ((phase) <= 0x4000) {					\
            (si) =   *(g_sintab+(phase));				\
    	  } else {							\
      	    (si) =   *(g_sintab+(unsigned WORD)(0x8000 - (phase)));	\
	  }								\
	} else {							\
 	  if ((phase) <= 0xC000) {					\
            (si) = - *(g_sintab+(unsigned WORD)((phase) - 0x8000));	\
    	  } else {							\
            (si) = - *(g_sintab+(unsigned WORD)(-(phase)));		\
	  }								\
	}

#define COSINUS(phase, co)						\
	if ((phase) < 0x8000) {						\
    	  if ((phase) <= 0x4000) {					\
	    (co) =   *(g_sintab+(unsigned WORD)(0x4000 - (phase)));	\
    	  } else {							\
      	    (co) = - *(g_sintab+(unsigned WORD)((phase) - 0x4000));	\
	  }								\
	} else {							\
 	  if ((phase) <= 0xC000) {					\
            (co) = - *(g_sintab+(unsigned WORD)(0xC000 - (phase)));	\
    	  } else {							\
	    (co) =   *(g_sintab+(unsigned WORD)((phase) - 0xC000));	\
	  }								\
	}

extern WORD g_sintab[];

#endif					/* SINTAB_INCLUDED		*/
/*******Dateiende********************************************************/
